Index: trunk/i18n/ru.ts
===================================================================
--- trunk/i18n/ru.ts	(revision 53)
+++ trunk/i18n/ru.ts	(revision 54)
@@ -37,6 +37,6 @@
         <location filename="../src/tspmodel.cpp" line="201"/>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Task Load</source>
         <translation>Загрузка условия</translation>
@@ -47,6 +47,6 @@
         <location filename="../src/tspmodel.cpp" line="201"/>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Unable to load task:</source>
         <translation>Невозможно загрузить условие:</translation>
@@ -66,5 +66,5 @@
     <message>
         <location filename="../src/tspmodel.cpp" line="201"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -74,5 +74,5 @@
     <message>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -81,17 +81,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="285"/>
-        <location filename="../src/tspmodel.cpp" line="291"/>
-        <location filename="../src/tspmodel.cpp" line="298"/>
-        <location filename="../src/tspmodel.cpp" line="305"/>
-        <location filename="../src/tspmodel.cpp" line="312"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="326"/>
-        <location filename="../src/tspmodel.cpp" line="336"/>
+        <location filename="../src/tspmodel.cpp" line="289"/>
+        <location filename="../src/tspmodel.cpp" line="295"/>
+        <location filename="../src/tspmodel.cpp" line="302"/>
+        <location filename="../src/tspmodel.cpp" line="309"/>
+        <location filename="../src/tspmodel.cpp" line="316"/>
+        <location filename="../src/tspmodel.cpp" line="323"/>
+        <location filename="../src/tspmodel.cpp" line="330"/>
+        <location filename="../src/tspmodel.cpp" line="340"/>
         <source>Task Save</source>
         <translation>Сохранение условия</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="285"/>
+        <location filename="../src/tspmodel.cpp" line="289"/>
         <source>Unable to create task file.
 Error: %1
@@ -102,11 +102,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="291"/>
-        <location filename="../src/tspmodel.cpp" line="298"/>
-        <location filename="../src/tspmodel.cpp" line="305"/>
-        <location filename="../src/tspmodel.cpp" line="312"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="326"/>
-        <location filename="../src/tspmodel.cpp" line="336"/>
+        <location filename="../src/tspmodel.cpp" line="295"/>
+        <location filename="../src/tspmodel.cpp" line="302"/>
+        <location filename="../src/tspmodel.cpp" line="309"/>
+        <location filename="../src/tspmodel.cpp" line="316"/>
+        <location filename="../src/tspmodel.cpp" line="323"/>
+        <location filename="../src/tspmodel.cpp" line="330"/>
+        <location filename="../src/tspmodel.cpp" line="340"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -118,27 +118,29 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="137"/>
+        <location filename="../src/tspsolver.cpp" line="138"/>
         <source>%v of %m parts found</source>
         <translation>Найдено %v з %m переходов</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="141"/>
+        <location filename="../src/tspsolver.cpp" line="142"/>
         <source>Calculating optimal route...</source>
         <translation>Расчет оптимального пути...</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="142"/>
+        <location filename="../src/tspsolver.cpp" line="143"/>
         <source>Solution Progress</source>
         <translation>Состояние решения</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="210"/>
+        <location filename="../src/tspsolver.cpp" line="209"/>
         <source>Solution Result</source>
         <translation>Результат решения</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="210"/>
-        <source>This task has no solution.</source>
-        <translation>У данной задачи нет решения.</translation>
+        <location filename="../src/tspsolver.cpp" line="209"/>
+        <source>Unable to find solution.
+Maybe, this task has no solutions.</source>
+        <translation>Не удалось найти решение.
+Возможно, у задачи нет решения.</translation>
     </message>
 </context>
@@ -146,70 +148,75 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="146"/>
-        <location filename="../src/mainwindow.cpp" line="492"/>
-        <location filename="../src/mainwindow.cpp" line="501"/>
+        <location filename="../src/mainwindow.cpp" line="540"/>
+        <location filename="../src/mainwindow.cpp" line="549"/>
         <source>Language change</source>
         <translation>Смена языка</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="146"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
         <source>Unable to load translation language.</source>
         <translation>Невозможно загрузить перевод.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="170"/>
+        <location filename="../src/mainwindow.cpp" line="186"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
         <source>Travelling Salesman Problem</source>
         <translation>Задача коммивояжера</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="192"/>
+        <location filename="../src/mainwindow.cpp" line="204"/>
         <source>Unsaved Changes</source>
         <translation>Несохраненные изменения</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="236"/>
         <source>All Supported Formats</source>
         <translation>Все поддерживаемые форматы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="227"/>
-        <location filename="../src/mainwindow.cpp" line="267"/>
-        <location filename="../src/mainwindow.cpp" line="296"/>
+        <location filename="../src/mainwindow.cpp" line="239"/>
+        <location filename="../src/mainwindow.cpp" line="289"/>
+        <location filename="../src/mainwindow.cpp" line="323"/>
         <source>All Files</source>
         <translation>Все файлы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="225"/>
-        <location filename="../src/mainwindow.cpp" line="226"/>
+        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="238"/>
         <source>%1 Task Files</source>
         <translation>Файлы условий %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="192"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
+        <source>Language Change</source>
+        <translation>Смена языка</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="204"/>
         <source>Would you like to save changes in current task?</source>
         <translation>Желаете сохранить изменения в текущей задаче?</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="263"/>
+        <location filename="../src/mainwindow.cpp" line="285"/>
         <source>HTML Files</source>
         <translation>Файлы HTML</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="265"/>
+        <location filename="../src/mainwindow.cpp" line="287"/>
         <source>OpenDocument Files</source>
         <translation>Файлы OpenDocument</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="295"/>
+        <location filename="../src/mainwindow.cpp" line="322"/>
         <source>%1 Task File</source>
         <translation>Файл условия %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="326"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
         <source>Settings Changed</source>
         <translation>Параметры изменены</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="326"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
         <source>You have changed color settings.
 Do you wish to apply them to current solution text?</source>
@@ -218,56 +225,56 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="390"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Data error</source>
         <translation>Ошибка в данных</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="390"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="403"/>
+        <location filename="../src/mainwindow.cpp" line="451"/>
         <source>Variant #%1</source>
         <translation>Вариант №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="404"/>
+        <location filename="../src/mainwindow.cpp" line="452"/>
         <source>Task:</source>
         <translation>Условие:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="407"/>
-        <location filename="../src/mainwindow.cpp" line="433"/>
+        <location filename="../src/mainwindow.cpp" line="455"/>
+        <location filename="../src/mainwindow.cpp" line="481"/>
         <source>Solution of Variant #%1 task</source>
         <translation>Решение варианта №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="414"/>
+        <location filename="../src/mainwindow.cpp" line="462"/>
         <source>Step #%1</source>
         <translation>Шаг №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="417"/>
+        <location filename="../src/mainwindow.cpp" line="465"/>
         <source>This step has alternate candidates for branching.</source>
         <translation>У этого шага есть альтернативные кандидаты на ветвление.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="429"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Optimal path:</source>
         <translation>Оптимальный путь:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="431"/>
+        <location filename="../src/mainwindow.cpp" line="479"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation>Стоимость - &lt;b&gt;%1&lt;/b&gt; единиц.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="492"/>
+        <location filename="../src/mainwindow.cpp" line="540"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Язык будет автоматически определен при следующем запуске приложения.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="501"/>
+        <location filename="../src/mainwindow.cpp" line="549"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -278,41 +285,36 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="506"/>
-        <location filename="../src/mainwindow.h" line="76"/>
+        <location filename="../src/mainwindow.h" line="78"/>
+        <location filename="../src/mainwindow.cpp" line="263"/>
+        <location filename="../src/mainwindow.cpp" line="554"/>
         <source>Untitled</source>
         <translation>Без имени</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="53"/>
-        <location filename="../ui/mainwindow.ui" line="41"/>
+        <location filename="../ui/mainwindow.ui" line="44"/>
         <source>Task</source>
         <translation>Условие</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="74"/>
-        <location filename="../ui/mainwindow.ui" line="62"/>
+        <location filename="../ui/mainwindow.ui" line="65"/>
         <source>&amp;Variant:</source>
         <translation>&amp;Вариант:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="87"/>
-        <location filename="../ui/mainwindow.ui" line="75"/>
+        <location filename="../ui/mainwindow.ui" line="78"/>
         <source>Number of variant</source>
         <translation>Номер варианта</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="97"/>
-        <location filename="../ui/mainwindow.ui" line="85"/>
+        <location filename="../ui/mainwindow.ui" line="88"/>
         <source>&amp;Cities:</source>
         <translation>&amp;Городов:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="110"/>
-        <location filename="../ui/mainwindow.ui" line="98"/>
+        <location filename="../ui/mainwindow.ui" line="101"/>
         <source>Number of cities</source>
         <translation>Количество городов, которые обходит коммивояжер</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="141"/>
         <location filename="../ui/mainwindow.ui" line="129"/>
         <source>Cost of travel from city to city</source>
@@ -320,5 +322,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="169"/>
         <location filename="../ui/mainwindow.ui" line="157"/>
         <source>Fill table with random numbers</source>
@@ -326,5 +327,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="172"/>
         <location filename="../ui/mainwindow.ui" line="160"/>
         <source>Random</source>
@@ -332,5 +332,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="186"/>
         <location filename="../ui/mainwindow.ui" line="174"/>
         <source>Solve current task</source>
@@ -338,5 +337,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="189"/>
         <location filename="../ui/mainwindow.ui" line="177"/>
         <source>Solve</source>
@@ -344,5 +342,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="203"/>
         <location filename="../ui/mainwindow.ui" line="191"/>
         <source>Solution</source>
@@ -350,5 +347,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="212"/>
         <location filename="../ui/mainwindow.ui" line="200"/>
         <source>Solution steps</source>
@@ -356,18 +352,31 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="242"/>
-        <location filename="../ui/mainwindow.ui" line="230"/>
+        <location filename="../ui/mainwindow.ui" line="221"/>
+        <location filename="../ui/mainwindow.ui" line="424"/>
+        <source>Save solution to a file</source>
+        <translation>Сохранить решение в файл</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="224"/>
+        <source>Save Solution</source>
+        <translation>Сохранить</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="251"/>
+        <source>Go back to Task tab</source>
+        <translation>Вернуться к закладке &quot;Условие&quot;</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="254"/>
+        <source>Back to Task</source>
+        <translation>К условию</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="284"/>
         <source>&amp;File</source>
         <translation>&amp;Файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="249"/>
-        <location filename="../ui/mainwindow.ui" line="234"/>
-        <source>Save &amp;As...</source>
-        <translation>Сохранить &amp;как...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="277"/>
-        <location filename="../ui/mainwindow.ui" line="265"/>
+        <location filename="../ui/mainwindow.ui" line="316"/>
         <source>&amp;Language</source>
         <comment>Please, append &quot; / Language&quot; when translating this string.</comment>
